package weaver.interfaces.thwl.cronjob;

import org.apache.commons.lang3.StringUtils;
import weaver.common.DateUtil;
import weaver.conn.RecordSet;
import weaver.hrm.company.DepartmentComInfo;
import weaver.hrm.resource.ResourceComInfo;
import weaver.interfaces.schedule.BaseCronJob;
import weaver.interfaces.thwl.action.sdk.ArtemisUtil;
import weaver.interfaces.thwl.action.sdk.OrgInfoRequest;
import weaver.interfaces.thwl.action.sdk.PersonInfoRequest;
import weaver.interfaces.thwl.action.sdk.UpdateRequest;

import java.util.*;

/**
 * @author:dxfeng
 * @createTime: 2024/08/14
 * @version: 1.0
 */
public class PersonSyncUpdateJob extends BaseCronJob {
    @Override
    public void execute() {
        RecordSet rs = new RecordSet();
        try {
            String currentDate = DateUtil.getCurrentDate();
            rs.executeQuery("select ydryxm,drgzbm from formtable_main_176 where dgrq = ? ", currentDate);
            List<Map<String, String>> personList = new ArrayList<>();
            while (rs.next()) {
                Map<String, String> map = new HashMap<>();
                map.put(rs.getString("ydryxm"), rs.getString("drgzbm"));
                personList.add(map);
            }
            rs.writeLog("人员异动同步任务开始，共查询到异动人员" + personList.size());

            DepartmentComInfo departmentComInfo = new DepartmentComInfo();
            ResourceComInfo resourceComInfo = new ResourceComInfo();
            for (Map<String, String> item : personList) {
                try {
                    String ydryxm = item.get("ydryxm");
                    String drgzbm = item.get("drgzbm");
                    String departmentCode = departmentComInfo.getDepartmentCode(drgzbm);
                    ArrayList<String> codeList = new ArrayList<>();
                    codeList.add(departmentCode);
                    OrgInfoRequest orgInfoRequest = new OrgInfoRequest();
                    orgInfoRequest.setOrgIndexCodes(codeList);

                    // 获取组织唯一标识
                    String orgIndexCode = ArtemisUtil.getOrgIndexCode(orgInfoRequest);

                    // 获取人员ID
                    String workCode = resourceComInfo.getWorkcode(ydryxm);
                    PersonInfoRequest personInfoRequest = new PersonInfoRequest();
                    personInfoRequest.setParamName("");
                    ArrayList<String> list = new ArrayList<>();
                    list.add(workCode);
                    personInfoRequest.setParamValue(list);
                    String personId = ArtemisUtil.getPersonId(personInfoRequest);
                    rs.writeLog("ydryxm==" + ydryxm + ",drgzbm==" + drgzbm + ",workCode==" + workCode + ",personId==" + personId);
                    if(StringUtils.isBlank(workCode) || StringUtils.isBlank(personId)){
                        continue;
                    }

                    UpdateRequest updateRequest = new UpdateRequest();
                    updateRequest.setPersonId(personId);
                    updateRequest.setOrgIndexCode(orgIndexCode);
                    ArtemisUtil.personSingleUpdate(updateRequest);
                } catch (Exception e) {
                    rs.writeLog(e);
                }
            }
        } catch (Exception e) {
            rs.writeLog("人员异动同步失败", e);
        }
    }
}
